<template>
  <div
    data-component-group="lists"
    data-component="billing-reports"
  >
    <ul class="contracts-list">
      <li
        v-for="contract in contracts"
        :key="contract.id"
        class="contract-item"
      >
        <span class="contract-title">
          {{ 'Billing account' }}
        </span>

        <BillingReportPanel :report="contract" />

        <div class="report-title">
          <div class="time-period">
            <span class="country-label">
              {{ contract.country.label }}
            </span>
            <span class="separator">
              {{ ' / ' }}
            </span>
            <MonthsDropdown
              :selected-month="contract.monthlyReport.month"
              :on-change="(month) => onChangeMonth(month, contract)"
            />
          </div>

          <div
            v-if="hasMonthlyReport(contract)"
            class="report-meta"
          >
            <span class="meta-label">
              {{ contract.monthlyReport.contract_label.id }}
            </span>
            <span class="meta-value">
              {{ contract.monthlyReport.contract_label.domain }}
            </span>
          </div>
        </div>

        <template v-if="hasMonthlyReport(contract)">
          <StatsPanel :report="contract.monthlyReport" />
        </template>

        <div
          v-if="!hasMonthlyReport(contract)"
          class="no-items-label"
        >
          {{ 'There are no reports for the selected period.' }}
        </div>
      </li>
    </ul>
  </div>
</template>

<script>
  import BillingReportPanel from '../panels/reports/Billing';
  import StatsPanel from '../panels/reports/Stats';
  import MonthsDropdown from '../dropdowns/Months';
  import { isNum } from '../../utils';

  export default {
    components: {
      BillingReportPanel,
      StatsPanel,
      MonthsDropdown
    },
    props: {
      contracts: {
        type: Array,
        required: true
      },
      onChangeMonth: {
        type: Function,
        required: true
      }
    },
    methods: {
      hasMonthlyReport(contract) {
        return isNum(contract.monthlyReport.id);
      }
    }
  };
</script>

<style lang="stylus" scoped>
  @import '../../assets/stylus/theme.styl';

  [data-component-group="lists"] {
    &[data-component="billing-reports"] {
      .contracts-list {
        list-style-type: none;
        padding: 0;
        margin: 0;

        .contract-item {
          margin: 0 0 60px 0;
        }
      }

      .contract-title {
        display: block;
        font-size: 24px;
        font-weight: 300;
        margin: 0 0 10px 0;
      }

      .report-title {
        margin: 30px 0 10px 0;

        .time-period {
          display: flex;
          justify-content: flex-start;
          align-items: center;
          margin: 0 0 20px 0;

          .country-label {
            font-size: 20px;
            font-weight: 300;
          }

          .separator {
            display: inline-block;
            font-size: 20px;
            font-weight: 300;
            margin: 0 10px;
            color: $colors.grey.base;
          }
        }

        .report-meta {
          font-size: 20px;

          .meta-label {
            display: inline-block;
            color: $colors.grey.base;
            margin: 0 20px 0 0;
          }
        }
      }

      .no-items-label {
        display: flex;
        justify-content: center;
        align-items: center;
        text-align: center;
        padding: 30px;
        margin: 10px 0 0 0;
        border-radius: 4px;
        background-color: $colors.grey.lighten-4;
      }
    }
  }
</style>
